"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Compose = Compose;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function () {
    return data;
  };

  return data;
}

/**
 * A react Component composer. equivalent to `(n+1) => <a[n+1]> <Compose(a[n]) /> </a[n+1]>`.
 * Component can be a React Component, or a `[Component, { ...props }]` tuple.
 */
function Compose(props) {
  const {
    components = [],
    children
  } = props;
  const arrayified = components.map(tuple => Array.isArray(tuple) ? tuple : [tuple, undefined]);
  return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, arrayified.reduceRight((acc, [Comp, forwardProps]) => {
    return /*#__PURE__*/_react().default.createElement(Comp, forwardProps, acc);
  }, children));
}

//# sourceMappingURL=compose.js.map